=== modified file 'drizzled/item.cc'
--- drizzled/item.cc	2011-01-26 02:13:21 +0000
+++ drizzled/item.cc	2011-01-28 02:32:26 +0000
@@ -961,7 +961,7 @@
           best match, they must reference the same column, otherwise the field
           is ambiguous.
         */
-        my_error(ER_NON_UNIQ_ERROR, MYF(0), find_item->full_name(), current_session->where);
+        my_error(ER_NON_UNIQ_ERROR, MYF(0), find_item->full_name(), current_session->where());
         return NULL;
       }
     }
@@ -1006,7 +1006,7 @@
       ambiguous_fields= true;
       push_warning_printf(session, DRIZZLE_ERROR::WARN_LEVEL_WARN, ER_NON_UNIQ_ERROR,
                           ER(ER_NON_UNIQ_ERROR), ref->full_name(),
-                          current_session->where);
+                          session->where());
 
     }
   }

=== modified file 'drizzled/item/field.cc'
--- drizzled/item/field.cc	2011-01-25 05:20:15 +0000
+++ drizzled/item/field.cc	2011-01-26 23:20:53 +0000
@@ -640,7 +640,7 @@
     if (upward_lookup)
     {
       // We can't say exactly what absent table or field
-      my_error(ER_BAD_FIELD_ERROR, MYF(0), full_name(), session->where);
+      my_error(ER_BAD_FIELD_ERROR, MYF(0), full_name(), session->where());
     }
     else
     {
@@ -824,7 +824,7 @@
             {
               /* The column to which we link isn't valid. */
               my_error(ER_BAD_FIELD_ERROR, MYF(0), (*res)->name,
-                       current_session->where);
+                       session->where());
               return(1);
             }
 

=== modified file 'drizzled/item/ref.cc'
--- drizzled/item/ref.cc	2011-01-25 05:20:15 +0000
+++ drizzled/item/ref.cc	2011-01-26 23:20:53 +0000
@@ -132,7 +132,7 @@
       {
         /* The current reference cannot be resolved in this query. */
         my_error(ER_BAD_FIELD_ERROR,MYF(0),
-                 this->full_name(), current_session->where);
+                 full_name(), session->where());
         goto error;
       }
 
@@ -285,7 +285,7 @@
       {
         /* The item was not a table field and not a reference */
         my_error(ER_BAD_FIELD_ERROR, MYF(0),
-                 this->full_name(), current_session->where);
+                 full_name(), session->where());
         goto error;
       }
       /* Should be checked in resolve_ref_in_select_and_group(). */

=== modified file 'drizzled/item/subselect.cc'
--- drizzled/item/subselect.cc	2011-01-12 21:31:39 +0000
+++ drizzled/item/subselect.cc	2011-01-26 23:20:53 +0000
@@ -180,7 +180,7 @@
 
 bool Item_subselect::fix_fields(Session *session_param, Item **ref)
 {
-  char const *save_where= session_param->where;
+  char const *save_where= session_param->where();
   bool res;
 
   assert(fixed == 0);
@@ -223,12 +223,13 @@
         engine->exclude();
       }
       substitution= 0;
-      session->where= "checking transformed subquery";
+      session->setWhere("checking transformed subquery");
       if (! (*ref)->fixed)
       {
         ret= (*ref)->fix_fields(session, ref);
       }
-      session->where= save_where;
+      session->setWhere(save_where);
+
       return ret;
     }
     // Is it one field subselect?
@@ -253,7 +254,7 @@
   fixed= 1;
 
 err:
-  session->where= save_where;
+  session->setWhere(save_where);
   return res;
 }
 
@@ -1650,7 +1651,7 @@
 Item_in_subselect::select_in_like_transformer(Join *join, const Comp_creator *func)
 {
   Select_Lex *current= session->lex->current_select, *up;
-  const char *save_where= session->where;
+  const char *save_where= session->where();
   Item_subselect::trans_res res= RES_ERROR;
   bool result;
 
@@ -1670,7 +1671,7 @@
   if (changed)
     return(RES_OK);
 
-  session->where= "IN/ALL/ANY subquery";
+  session->setWhere("IN/ALL/ANY subquery");
 
   /*
     In some optimisation cases we will not need this Item_in_optimizer
@@ -1721,7 +1722,7 @@
     res= row_value_transformer(join);
   }
 err:
-  session->where= save_where;
+  session->setWhere(save_where);
   return(res);
 }
 
@@ -2142,7 +2143,7 @@
 
 int subselect_single_select_engine::exec()
 {
-  char const *save_where= session->where;
+  char const *save_where= session->where();
   Select_Lex *save_select= session->lex->current_select;
   session->lex->current_select= select_lex;
   if (!join->optimized)
@@ -2152,7 +2153,7 @@
     unit->set_limit(unit->global_parameters);
     if (join->optimize())
     {
-      session->where= save_where;
+      session->setWhere(save_where);
       executed= 1;
       session->lex->current_select= save_select;
       return(join->error ? join->error : 1);
@@ -2171,7 +2172,7 @@
   {
     if (join->reinit())
     {
-      session->where= save_where;
+      session->setWhere(save_where);
       session->lex->current_select= save_select;
       return 1;
     }
@@ -2230,11 +2231,11 @@
       tab->read_record.read_record= tab->save_read_record;
     }
     executed= 1;
-    session->where= save_where;
+    session->setWhere(save_where);
     session->lex->current_select= save_select;
     return(join->error||session->is_fatal_error);
   }
-  session->where= save_where;
+  session->setWhere(save_where);
   session->lex->current_select= save_select;
   return(0);
 }
@@ -2279,9 +2280,10 @@
 
 int subselect_union_engine::exec()
 {
-  char const *save_where= session->where;
+  char const *save_where= session->where();
   int res= unit->exec();
-  session->where= save_where;
+  session->setWhere(save_where);
+
   return res;
 }
 

=== modified file 'drizzled/join.cc'
--- drizzled/join.cc	2011-01-24 05:33:52 +0000
+++ drizzled/join.cc	2011-01-26 23:20:53 +0000
@@ -213,7 +213,7 @@
   if (having)
   {
     nesting_map save_allow_sum_func= session->lex->allow_sum_func;
-    session->where="having clause";
+    session->setWhere("having clause");
     session->lex->allow_sum_func|= 1 << select_lex_arg->nest_level;
     select_lex->having_fix_field= 1;
     bool having_fix_rc= (!having->fixed &&

=== modified file 'drizzled/parser.cc'
--- drizzled/parser.cc	2011-01-26 02:21:59 +0000
+++ drizzled/parser.cc	2011-01-26 23:20:53 +0000
@@ -263,9 +263,9 @@
   }
 }
 
-bool buildOrderBy(Session *session)
+bool buildOrderBy(LEX *lex)
 {
-  Select_Lex *sel= session->getLex()->current_select;
+  Select_Lex *sel= lex->current_select;
   Select_Lex_Unit *unit= sel-> master_unit();
 
   if (sel->linkage != GLOBAL_OPTIONS_TYPE &&
@@ -277,7 +277,7 @@
     return false;
   }
 
-  if (session->getLex()->sql_command != SQLCOM_ALTER_TABLE && !unit->fake_select_lex)
+  if (lex->sql_command != SQLCOM_ALTER_TABLE && !unit->fake_select_lex)
   {
     /*
       A query of the of the form (SELECT ...) ORDER BY order_list is
@@ -291,7 +291,7 @@
     if (!unit->is_union() &&
         (first_sl->order_list.elements ||
          first_sl->select_limit) &&           
-        unit->add_fake_select_lex(session->getLex()->session))
+        unit->add_fake_select_lex(lex->session))
     {
       return false;
     }
@@ -300,39 +300,39 @@
   return true;
 }
 
-void buildEngineOption(Session *session, const char *key, const LEX_STRING &value)
-{
-  message::Engine::Option *opt= session->getLex()->table()->mutable_engine()->add_options();
-  opt->set_name(key);
-  opt->set_state(value.str, value.length);
-}
-
-void buildEngineOption(Session *session, const char *key, uint64_t value)
-{
-  drizzled::message::Engine::Option *opt= session->getLex()->table()->mutable_engine()->add_options();
-  opt->set_name(key);
-  opt->set_state(boost::lexical_cast<std::string>(value));
-}
-
-void buildSchemaOption(Session *session, const char *key, const LEX_STRING &value)
-{
-  statement::CreateSchema *statement= (statement::CreateSchema *)session->getLex()->statement;
-  message::Engine::Option *opt= statement->schema_message.mutable_engine()->add_options();
-  opt->set_name(key);
-  opt->set_state(value.str, value.length);
-}
-
-void buildSchemaOption(Session *session, const char *key, uint64_t value)
-{
-  statement::CreateSchema *statement= (statement::CreateSchema *)session->getLex()->statement;
-  message::Engine::Option *opt= statement->schema_message.mutable_engine()->add_options();
-  opt->set_name(key);
-  opt->set_state(boost::lexical_cast<std::string>(value));
-}
-
-bool checkFieldIdent(Session *session, const LEX_STRING &schema_name, const LEX_STRING &table_name)
-{
-  TableList *table= reinterpret_cast<TableList*>(session->getLex()->current_select->table_list.first);
+void buildEngineOption(LEX *lex, const char *key, const LEX_STRING &value)
+{
+  message::Engine::Option *opt= lex->table()->mutable_engine()->add_options();
+  opt->set_name(key);
+  opt->set_state(value.str, value.length);
+}
+
+void buildEngineOption(LEX *lex, const char *key, uint64_t value)
+{
+  drizzled::message::Engine::Option *opt= lex->table()->mutable_engine()->add_options();
+  opt->set_name(key);
+  opt->set_state(boost::lexical_cast<std::string>(value));
+}
+
+void buildSchemaOption(LEX *lex, const char *key, const LEX_STRING &value)
+{
+  statement::CreateSchema *statement= (statement::CreateSchema *)lex->statement;
+  message::Engine::Option *opt= statement->schema_message.mutable_engine()->add_options();
+  opt->set_name(key);
+  opt->set_state(value.str, value.length);
+}
+
+void buildSchemaOption(LEX *lex, const char *key, uint64_t value)
+{
+  statement::CreateSchema *statement= (statement::CreateSchema *)lex->statement;
+  message::Engine::Option *opt= statement->schema_message.mutable_engine()->add_options();
+  opt->set_name(key);
+  opt->set_state(boost::lexical_cast<std::string>(value));
+}
+
+bool checkFieldIdent(LEX *lex, const LEX_STRING &schema_name, const LEX_STRING &table_name)
+{
+  TableList *table= reinterpret_cast<TableList*>(lex->current_select->table_list.first);
 
   if (schema_name.length)
   {
@@ -353,25 +353,48 @@
   return true;
 }
 
-Item *buildIdent(Session *session,
+Item *buildIdent(LEX *lex,
                  const LEX_STRING &schema_name,
                  const LEX_STRING &table_name,
                  const LEX_STRING &field_name)
 {
-  Select_Lex *sel= session->getLex()->current_select;
+  Select_Lex *sel= lex->current_select;
 
-  if (sel->no_table_names_allowed)
+  if (table_name.length and sel->no_table_names_allowed)
   {
     my_error(ER_TABLENAME_NOT_ALLOWED_HERE,
-             MYF(0), table_name.str, session->where);
+             MYF(0), table_name.str, lex->session->where());
   }
 
   Item *item= (sel->parsing_place != IN_HAVING or
                sel->get_in_sum_expr() > 0) ?
-    (Item*) new Item_field(session->getLex()->current_context(), schema_name.str, table_name.str, field_name.str) :
-    (Item*) new Item_ref(session->getLex()->current_context(), schema_name.str, table_name.str, field_name.str);
-
-  return item;
+    (Item*) new Item_field(lex->current_context(), schema_name.str, table_name.str, field_name.str) :
+    (Item*) new Item_ref(lex->current_context(), schema_name.str, table_name.str, field_name.str);
+
+  return item;
+}
+
+Item *buildTableWild(LEX *lex, const LEX_STRING &schema_name, const LEX_STRING &table_name)
+{
+  Select_Lex *sel= lex->current_select;
+  Item *item= new Item_field(lex->current_context(), schema_name.str, table_name.str, "*");
+  sel->with_wild++;
+
+  return item;
+}
+
+void buildCreateFieldIdent(LEX *lex)
+{
+  statement::CreateTable *statement= (statement::CreateTable *)lex->statement;
+  lex->length= lex->dec=0;
+  lex->type=0;
+  statement->default_value= statement->on_update_value= 0;
+  statement->comment= null_lex_str;
+  lex->charset= NULL;
+  statement->column_format= COLUMN_FORMAT_TYPE_DEFAULT;
+
+  message::AlterTable &alter_proto= ((statement::CreateTable *)lex->statement)->alter_info.alter_proto;
+  lex->setField(alter_proto.add_added_field());
 }
 
 } // namespace parser

=== modified file 'drizzled/parser.h'
--- drizzled/parser.h	2011-01-26 02:21:59 +0000
+++ drizzled/parser.h	2011-01-26 21:33:37 +0000
@@ -134,14 +134,19 @@
 void my_parse_error(const char *message);
 bool check_reserved_words(LEX_STRING *name);
 void errorOn(const char *s);
-bool buildOrderBy(Session *session);
-void buildEngineOption(Session *session, const char *key, const LEX_STRING &value);
-void buildEngineOption(Session *session, const char *key, uint64_t value);
-void buildSchemaOption(Session *session, const char *key, const LEX_STRING &value);
-void buildSchemaOption(Session *session, const char *key, uint64_t value);
-bool checkFieldIdent(Session *session, const LEX_STRING &schema_name, const LEX_STRING &table_name);
-
-Item *buildIdent(Session *session, const LEX_STRING &schema_name, const LEX_STRING &table_name, const LEX_STRING &field_name);
+
+
+bool buildOrderBy(LEX *lex);
+void buildEngineOption(LEX *lex, const char *key, const LEX_STRING &value);
+void buildEngineOption(LEX *lex, const char *key, uint64_t value);
+void buildSchemaOption(LEX *lex, const char *key, const LEX_STRING &value);
+void buildSchemaOption(LEX *lex, const char *key, uint64_t value);
+bool checkFieldIdent(LEX *lex, const LEX_STRING &schema_name, const LEX_STRING &table_name);
+
+Item *buildIdent(LEX *lex, const LEX_STRING &schema_name, const LEX_STRING &table_name, const LEX_STRING &field_name);
+Item *buildTableWild(LEX *lex, const LEX_STRING &schema_name, const LEX_STRING &table_name);
+
+void buildCreateFieldIdent(LEX *lex);
 
 } // namespace parser
 } // namespace drizzled

=== modified file 'drizzled/session.cc'
--- drizzled/session.cc	2011-01-20 14:08:19 +0000
+++ drizzled/session.cc	2011-01-26 23:20:53 +0000
@@ -176,7 +176,7 @@
   lock_id(&main_lock_id),
   thread_stack(NULL),
   security_ctx(identifier::User::make_shared()),
-  where(Session::DEFAULT_WHERE),
+  _where(Session::DEFAULT_WHERE),
   dbug_sentry(Session_SENTRY_MAGIC),
   mysys_var(0),
   command(COM_CONNECT),
@@ -873,11 +873,14 @@
     first_successful_insert_id_in_cur_stmt= 0;
     substitute_null_with_insert_id= true;
   }
+
   arg_of_last_insert_id_function= false;
+
   /* Free Items that were created during this execution */
   free_items();
-  /* Reset where. */
-  where= Session::DEFAULT_WHERE;
+
+  /* Reset _where. */
+  _where= Session::DEFAULT_WHERE;
 
   /* Reset the temporary shares we built */
   for_each(temporary_shares.begin(),

=== modified file 'drizzled/session.h'
--- drizzled/session.h	2011-01-26 06:45:42 +0000
+++ drizzled/session.h	2011-01-28 02:32:26 +0000
@@ -623,12 +623,24 @@
    */
   bool isViewable(identifier::User::const_reference) const;
 
+private:
   /**
     Used in error messages to tell user in what part of MySQL we found an
     error. E. g. when where= "having clause", if fix_fields() fails, user
     will know that the error was in having clause.
   */
-  const char *where;
+  const char *_where;
+
+public:
+  const char *where()
+  {
+    return _where;
+  }
+
+  void setWhere(const char *arg)
+  {
+    _where= arg;
+  }
 
   /*
     One thread can hold up to one named user-level lock. This variable
@@ -636,6 +648,7 @@
     chapter 'Miscellaneous functions', for functions GET_LOCK, RELEASE_LOCK.
   */
   uint32_t dbug_sentry; /**< watch for memory corruption */
+
 private:
   boost::thread::id boost_thread_id;
   boost_thread_shared_ptr _thread;

=== modified file 'drizzled/sql_base.cc'
--- drizzled/sql_base.cc	2011-01-18 00:26:36 +0000
+++ drizzled/sql_base.cc	2011-01-26 23:20:53 +0000
@@ -1943,7 +1943,7 @@
     {
       if (nj_col)
       {
-        my_error(ER_NON_UNIQ_ERROR, MYF(0), name, session->where);
+        my_error(ER_NON_UNIQ_ERROR, MYF(0), name, session->where());
         return NULL;
       }
       nj_col= curr_nj_col;
@@ -2340,7 +2340,7 @@
       */
       item->cached_table= found ?  0 : actual_table;
 
-      assert(session->where);
+      assert(session->where());
       /*
         If we found a fully qualified field we return it directly as it can't
         have duplicates.
@@ -2353,7 +2353,7 @@
         if (report_error == REPORT_ALL_ERRORS ||
             report_error == IGNORE_EXCEPT_NON_UNIQUE)
           my_error(ER_NON_UNIQ_ERROR, MYF(0),
-                   table_name ? item->full_name() : name, session->where);
+                   table_name ? item->full_name() : name, session->where());
         return (Field*) 0;
       }
       found= cur_field;
@@ -2386,13 +2386,13 @@
       strcat(buff, table_name);
       table_name=buff;
     }
-    my_error(ER_UNKNOWN_TABLE, MYF(0), table_name, session->where);
+    my_error(ER_UNKNOWN_TABLE, MYF(0), table_name, session->where());
   }
   else
   {
     if (report_error == REPORT_ALL_ERRORS ||
         report_error == REPORT_EXCEPT_NON_UNIQUE)
-      my_error(ER_BAD_FIELD_ERROR, MYF(0), item->full_name(), session->where);
+      my_error(ER_BAD_FIELD_ERROR, MYF(0), item->full_name(), session->where());
     else
       found= not_found_field;
   }
@@ -2519,7 +2519,7 @@
             */
             if (report_error != IGNORE_ERRORS)
               my_error(ER_NON_UNIQ_ERROR, MYF(0),
-                       find->full_name(), session->where);
+                       find->full_name(), session->where());
             return (Item**) 0;
           }
           found_unaliased= li.ref();
@@ -2550,7 +2550,7 @@
               continue;                           // Same field twice
             if (report_error != IGNORE_ERRORS)
               my_error(ER_NON_UNIQ_ERROR, MYF(0),
-                       find->full_name(), session->where);
+                       find->full_name(), session->where());
             return (Item**) 0;
           }
           found= li.ref();
@@ -2602,7 +2602,7 @@
     {
       if (report_error != IGNORE_ERRORS)
         my_error(ER_NON_UNIQ_ERROR, MYF(0),
-                 find->full_name(), session->where);
+                 find->full_name(), session->where());
       return (Item **) 0;
     }
     if (found_unaliased)
@@ -2618,7 +2618,7 @@
   {
     if (report_error == REPORT_ALL_ERRORS)
       my_error(ER_BAD_FIELD_ERROR, MYF(0),
-               find->full_name(), session->where);
+               find->full_name(), session->where());
     return (Item **) 0;
   }
   else
@@ -2789,7 +2789,7 @@
         if (cur_nj_col_2->is_common ||
             (found && (!using_fields || is_using_column_1)))
         {
-          my_error(ER_NON_UNIQ_ERROR, MYF(0), field_name_1, session->where);
+          my_error(ER_NON_UNIQ_ERROR, MYF(0), field_name_1, session->where());
           return(result);
         }
         nj_col_2= cur_nj_col_2;
@@ -2994,7 +2994,7 @@
         if (!(common_field= it++))
         {
           my_error(ER_BAD_FIELD_ERROR, MYF(0), using_field_name_ptr,
-                   session->where);
+                   session->where());
           return(result);
         }
         if (!my_strcasecmp(system_charset_info,
@@ -3217,7 +3217,7 @@
                                          List<TableList> *from_clause,
                                          Name_resolution_context *context)
 {
-  session->where= "from clause";
+  session->setWhere("from clause");
   if (from_clause->elements == 0)
     return false; /* We come here in the case of UNIONs. */
 
@@ -3338,7 +3338,7 @@
   session->mark_used_columns= mark_used_columns;
   if (allow_sum_func)
     session->lex->allow_sum_func|= 1 << session->lex->current_select->nest_level;
-  session->where= Session::DEFAULT_WHERE;
+  session->setWhere(Session::DEFAULT_WHERE);
   save_is_item_list_lookup= session->lex->current_select->is_item_list_lookup;
   session->lex->current_select->is_item_list_lookup= 0;
 
@@ -3350,11 +3350,12 @@
     There is other way to solve problem: fill array with pointers to list,
     but it will be slower.
 
-TODO: remove it when (if) we made one list for allfields and
-ref_pointer_array
+    TODO-> remove it when (if) we made one list for allfields and ref_pointer_array
   */
   if (ref_pointer_array)
+  {
     memset(ref_pointer_array, 0, sizeof(Item *) * fields.elements);
+  }
 
   Item **ref= ref_pointer_array;
   session->lex->current_select->cur_pos_in_select_list= 0;
@@ -3729,7 +3730,7 @@
   session->session_marker= (void*)1;
   if (*conds)
   {
-    session->where="where clause";
+    session->setWhere("where clause");
     if ((!(*conds)->fixed && (*conds)->fix_fields(session, conds)) ||
         (*conds)->check_cols(1))
       goto err_no_arena;
@@ -3751,7 +3752,7 @@
       {
         /* Make a join an a expression */
         session->session_marker= (void*)embedded;
-        session->where="on clause";
+        session->setWhere("on clause");
         if ((!embedded->on_expr->fixed && embedded->on_expr->fix_fields(session, &embedded->on_expr)) ||
             embedded->on_expr->check_cols(1))
           goto err_no_arena;

=== modified file 'drizzled/sql_select.cc'
--- drizzled/sql_select.cc	2011-01-17 07:58:22 +0000
+++ drizzled/sql_select.cc	2011-01-26 23:20:53 +0000
@@ -5464,7 +5464,7 @@
     if (!count || count > fields.elements)
     {
       my_error(ER_BAD_FIELD_ERROR, MYF(0),
-               order_item->full_name(), session->where);
+               order_item->full_name(), session->where());
       return true;
     }
     order->item= ref_pointer_array + count - 1;
@@ -5541,7 +5541,7 @@
       push_warning_printf(session, DRIZZLE_ERROR::WARN_LEVEL_WARN, ER_NON_UNIQ_ERROR,
                           ER(ER_NON_UNIQ_ERROR),
                           ((Item_ident*) order_item)->field_name,
-                          session->where);
+                          session->where());
     }
   }
 
@@ -5583,7 +5583,7 @@
                 List<Item> &all_fields,
                 Order *order)
 {
-  session->where="order clause";
+  session->setWhere("order clause");
   for (; order; order=order->next)
   {
     if (find_order_in_list(session, ref_pointer_array, tables, order, fields,
@@ -5634,7 +5634,7 @@
 
   uint32_t org_fields=all_fields.elements;
 
-  session->where="group statement";
+  session->setWhere("group statement");
   for (ord= order; ord; ord= ord->next)
   {
     if (find_order_in_list(session, ref_pointer_array, tables, ord, fields,

=== modified file 'drizzled/sql_yacc.yy'
--- drizzled/sql_yacc.yy	2011-01-26 18:53:55 +0000
+++ drizzled/sql_yacc.yy	2011-01-28 02:32:26 +0000
@@ -647,7 +647,7 @@
         table_wild simple_expr udf_expr
         expr_or_default set_expr_or_default
         signed_literal now_or_signed_literal opt_escape
-        simple_ident_nospvar simple_ident_q
+        simple_ident_q
         field_or_var limit_option
         function_call_keyword
         function_call_nonkeyword
@@ -977,11 +977,11 @@
           }
         | ident_or_text equal ident_or_text
           {
-            parser::buildSchemaOption(YYSession, $1.str, $3);
+            parser::buildSchemaOption(Lex, $1.str, $3);
           }
         | ident_or_text equal ulonglong_num
           {
-            parser::buildSchemaOption(YYSession, $1.str, $3);
+            parser::buildSchemaOption(Lex, $1.str, $3);
           }
         ;
 
@@ -1028,19 +1028,19 @@
           }
         |  ROW_FORMAT_SYM equal row_format_or_text
           {
-            parser::buildEngineOption(YYSession, "ROW_FORMAT", $3);
+            parser::buildEngineOption(Lex, "ROW_FORMAT", $3);
           }
         |  FILE_SYM equal TEXT_STRING_sys
           {
-            parser::buildEngineOption(YYSession, "FILE", $3);
+            parser::buildEngineOption(Lex, "FILE", $3);
           }
         |  ident_or_text equal engine_option_value
           {
-            parser::buildEngineOption(YYSession, $1.str, $3);
+            parser::buildEngineOption(Lex, $1.str, $3);
           }
         | ident_or_text equal ulonglong_num
           {
-            parser::buildEngineOption(YYSession, $1.str, $3);
+            parser::buildEngineOption(Lex, $1.str, $3);
           }
         | default_collation
         ;
@@ -1182,16 +1182,7 @@
 field_spec:
           field_ident
           {
-            statement::CreateTable *statement= (statement::CreateTable *)Lex->statement;
-            Lex->length= Lex->dec=0;
-            Lex->type=0;
-            statement->default_value= statement->on_update_value= 0;
-            statement->comment= null_lex_str;
-            Lex->charset= NULL;
-            statement->column_format= COLUMN_FORMAT_TYPE_DEFAULT;
-
-            message::AlterTable &alter_proto= ((statement::CreateTable *)Lex->statement)->alter_info.alter_proto;
-            Lex->setField(alter_proto.add_added_field());
+            parser::buildCreateFieldIdent(Lex);
           }
           field_def
           {
@@ -1213,6 +1204,7 @@
             Lex->setField(NULL);
           }
         ;
+
 field_def:
           field_definition opt_attribute {}
         ;
@@ -2731,7 +2723,7 @@
             $$= new (YYSession->mem_root) Item_default_value(Lex->current_context(),
                                                          $3);
           }
-        | VALUES '(' simple_ident_nospvar ')'
+        | VALUES '(' simple_ident ')'
           {
             $$= new (YYSession->mem_root) Item_insert_value(Lex->current_context(),
                                                         $3);
@@ -3982,7 +3974,7 @@
         ;
 
 alter_order_item:
-          simple_ident_nospvar order_dir
+          simple_ident order_dir
           {
             bool ascending= ($2 == 1) ? true : false;
             if (YYSession->add_order_to_list($1, ascending))
@@ -4002,7 +3994,7 @@
 order_clause:
           ORDER_SYM BY
           {
-            if (not parser::buildOrderBy(YYSession))
+            if (not parser::buildOrderBy(Lex))
               DRIZZLE_YYABORT;
           }
           order_list
@@ -4358,7 +4350,7 @@
         ;
 
 ident_eq_value:
-          simple_ident_nospvar equal expr_or_default
+          simple_ident equal expr_or_default
           {
             if (Lex->field_list.push_back($1) ||
                 Lex->insert_list->push_back($3))
@@ -4455,7 +4447,7 @@
         ;
 
 update_elem:
-          simple_ident_nospvar equal expr_or_default
+          simple_ident equal expr_or_default
           {
             if (YYSession->add_item_to_list($1) || YYSession->add_value_to_list($3))
               DRIZZLE_YYABORT;
@@ -4468,7 +4460,7 @@
         ;
 
 insert_update_elem:
-          simple_ident_nospvar equal expr_or_default
+          simple_ident equal expr_or_default
           {
           if (Lex->update_list.push_back($1) ||
               Lex->value_list.push_back($3))
@@ -4912,7 +4904,7 @@
         ;
 
 field_or_var:
-          simple_ident_nospvar {$$= $1;}
+          simple_ident {$$= $1;}
         | '@' user_variable_ident
           { $$= new Item_user_var_as_out_param($2); }
         ;
@@ -5027,22 +5019,18 @@
 **********************************************************************/
 
 insert_ident:
-          simple_ident_nospvar { $$=$1; }
+          simple_ident { $$=$1; }
         | table_wild { $$=$1; }
         ;
 
 table_wild:
           ident '.' '*'
           {
-            Select_Lex *sel= Lex->current_select;
-            $$ = new Item_field(Lex->current_context(), NULL, $1.str, "*");
-            sel->with_wild++;
+            $$= parser::buildTableWild(Lex, NULL_LEX_STRING, $1);
           }
         | ident '.' ident '.' '*'
           {
-            Select_Lex *sel= Lex->current_select;
-            $$ = new Item_field(Lex->current_context(), $1.str, $3.str,"*");
-            sel->with_wild++;
+            $$= parser::buildTableWild(Lex, $1, $3);
           }
         ;
 
@@ -5053,29 +5041,7 @@
 simple_ident:
           ident
           {
-            {
-              Select_Lex *sel=Lex->current_select;
-              $$= (sel->parsing_place != IN_HAVING ||
-                  sel->get_in_sum_expr() > 0) ?
-                  (Item*) new Item_field(Lex->current_context(),
-                                         (const char *)NULL, NULL, $1.str) :
-                  (Item*) new Item_ref(Lex->current_context(),
-                                       (const char *)NULL, NULL, $1.str);
-            }
-          }
-        | simple_ident_q { $$= $1; }
-        ;
-
-simple_ident_nospvar:
-          ident
-          {
-            Select_Lex *sel=Lex->current_select;
-            $$= (sel->parsing_place != IN_HAVING ||
-                sel->get_in_sum_expr() > 0) ?
-                (Item*) new Item_field(Lex->current_context(),
-                                       (const char *)NULL, NULL, $1.str) :
-                (Item*) new Item_ref(Lex->current_context(),
-                                     (const char *)NULL, NULL, $1.str);
+            $$= parser::buildIdent(Lex, NULL_LEX_STRING, NULL_LEX_STRING, $1);
           }
         | simple_ident_q { $$= $1; }
         ;
@@ -5083,15 +5049,15 @@
 simple_ident_q:
           ident '.' ident
           {
-            $$= parser::buildIdent(YYSession, NULL_LEX_STRING, $1, $3);
+            $$= parser::buildIdent(Lex, NULL_LEX_STRING, $1, $3);
           }
         | '.' ident '.' ident
           {
-            $$= parser::buildIdent(YYSession, NULL_LEX_STRING, $2, $4);
+            $$= parser::buildIdent(Lex, NULL_LEX_STRING, $2, $4);
           }
         | ident '.' ident '.' ident
           {
-            $$= parser::buildIdent(YYSession, $1, $3, $5);
+            $$= parser::buildIdent(Lex, $1, $3, $5);
           }
         ;
 
@@ -5102,14 +5068,14 @@
           }
         | ident '.' ident '.' ident
           {
-            if (not parser::checkFieldIdent(YYSession, $1, $3))
+            if (not parser::checkFieldIdent(Lex, $1, $3))
               DRIZZLE_YYABORT;
 
             $$=$5;
           }
         | ident '.' ident
           {
-            if (not parser::checkFieldIdent(YYSession, NULL_LEX_STRING, $1))
+            if (not parser::checkFieldIdent(Lex, NULL_LEX_STRING, $1))
               DRIZZLE_YYABORT;
 
             $$=$3;
@@ -5121,9 +5087,18 @@
         ;
 
 table_ident:
-          ident { $$=new Table_ident($1); }
-        | schema_name '.' ident { $$=new Table_ident($1,$3);}
-        | '.' ident { $$=new Table_ident($2);} /* For Delphi */
+          ident
+          {
+            $$= new Table_ident($1);
+          }
+        | schema_name '.' ident
+          {
+            $$=new Table_ident($1,$3);
+          }
+        | '.' ident
+        { /* For Delphi */
+          $$= new Table_ident($2);
+        }
         ;
 
 schema_name:
@@ -5625,12 +5600,12 @@
               fake->no_table_names_allowed= 1;
               Lex->current_select= fake;
             }
-            YYSession->where= "global ORDER clause";
+            YYSession->setWhere("global ORDER clause");
           }
           order_or_limit
           {
             YYSession->lex->current_select->no_table_names_allowed= 0;
-            YYSession->where= "";
+            YYSession->setWhere("");
           }
         ;
 

